package com.iformall.controller.market;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.WxCouponCar;
import com.iformall.service.WxCouponCarService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("wxCouponCar")
@Api(description = "停车券接口")
public class WxCouponCarController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxCouponCarService wxCouponCarService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "停车券-列表")
    public ResultData list(@ModelAttribute WxCouponCar wxCouponCar, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxCouponCarController::list");
        if (null == wxCouponCar) wxCouponCar = new WxCouponCar();
        final PageInfo<WxCouponCar> page = wxCouponCarService.listAsPage(wxCouponCar, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "停车券-新增")
    public ResultData add(@RequestBody WxCouponCar wxCouponCar) {
        logger.debug("[" + getIpAddr() + "] WxCouponCarController::add");
        //Assert.notNull(wxCouponCar.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxCouponCarService.save(wxCouponCar);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "停车券-更新")
    public ResultData update(@RequestBody WxCouponCar wxCouponCar) {
        logger.debug("[" + getIpAddr() + "] WxCouponCarController::update");
        wxCouponCarService.update(wxCouponCar);
        return new ResultData();
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "停车券-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCouponCarController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxCouponCarService.getById(id));
    }


}
